# Record Class CAItemSerial

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CAItemSerial

Record Components:
  `type` - The type
  `value` - The value

All Implemented Interfaces:
  `Comparable<CAItemSerial>`

public record CAItemSerial(com.io7m.lanark.core.RDottedName type, String value) extends Record implements Comparable<CAItemSerial>
A serial number.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CAItemSerial(com.io7m.lanark.core.RDottedName type, String value)`
  A serial number.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CAItemSerial other)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `static CAItemSerial`
  `parse(String text)`
  Parse a serial number of the form "<type>:<value>".
  `String`
  `toString()`
  Returns a string representation of this record class.
  `com.io7m.lanark.core.RDottedName`
  `type()`
  Returns the value of the `type` record component.
  `String`
  `value()`
  Returns the value of the `value` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CAItemSerial

    public CAItemSerial(com.io7m.lanark.core.RDottedName type, String value)
    A serial number.
    Parameters:
      `type` - The type
      `value` - The value

- ## Method Details

  - ### toString

    public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### parse

    public static CAItemSerial parse(String text) throws IllegalArgumentException
    Parse a serial number of the form "<type>:<value>".
    Parameters:
      `text` - The text
    Returns:
      The parsed serial number
    Throws:
      `IllegalArgumentException` - On parse errors

  - ### compareTo

    public int compareTo(CAItemSerial other)
    Specified by:
      `compareTo` in interface `Comparable<CAItemSerial>`

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### type

    public com.io7m.lanark.core.RDottedName type()
    Returns the value of the `type` record component.
    Returns:
      the value of the `type` record component

  - ### value

    public String value()
    Returns the value of the `value` record component.
    Returns:
      the value of the `value` record component